$ on control_y then goto make_exit
$ on error     then continue
$! 
$!***************************
$! Argument Description
$!***************************
$! in most cases just say
$!
$! $@make
$! 
$! but if you want more control specify one or more
$! of the following arguments in no particular order:
$! Compiler:             VAXC, DECC or GNUC
$! make-util:            mms, mmk or nomms
$! make-util-options:    "/some /options"
$! Example:
$! $@make GNUC mmk "/from"
$!***************************
$! Process Arguments
$!***************************
$ make_type = ""
$ make_options = ""
$ compiler = ""
$ vms_version = f$getsyi("VERSION")
$ gosub scan_parameters
$!
$!***************************
$! Initialize
$!***************************
$ say     := write SYS$OUTPUT
$ facility = "%ACCSTATMAKE"
$!
$ gosub check_platform
$ gosub check_parameters
$ gosub compile_'make_type'
$ goto make_exit
$!
$!***************************
$! Compile MMS
$!***************************
$ compile_mms:
$ mms/description=accstat.mms 'make_options'
$ return
$!
$!***************************
$! Compile MMK
$!***************************
$ compile_mmk:
$ mmk/description=accstat.mms 'make_options'
$ return
$!
$!***************************
$! Compile NOMMS
$!***************************
$ compile_nomms:
$ on error then goto  compile_nomms_exit
$! set process/priority=3
$ say "''cc' ''CFLAGS' accstat.c"
$ 'cc' 'CFLAGS'  accstat.c
$ number = 0
$ acc_comp_loop:
$   modul = f$element (number, ",", Modules)
$   if (modul .eqs. ",") then goto acc_comp_loop_exit
$   modul = f$element (0, ".", modul) + ".c"
$   say "''cc' ''CFLAGS' ''modul'"
$   'cc' 'CFLAGS' 'modul'
$   number = number + 1
$   goto acc_comp_loop
$ acc_comp_loop_exit:
$! gd1.2 library
$ number = 0
$ If F$Search(gdlib) .EQS. "" Then LIBRARY/Create 'gdlib'
$ gd_comp_loop:
$   modul = f$element (number, " ", GDModules)
$   if (modul .eqs. " ") then goto gd_comp_loop_exit
$   say "''cc' ''CFLAGS' ''modul'.c"
$   'cc' 'CFLAGS' 'modul'.c
$   say "library/replace ''gdlib' ''modul'.obj"
$   library/replace 'gdlib' 'modul'.obj
$   number = number + 1
$   goto gd_comp_loop
$ gd_comp_loop_exit:
$ set verify
$ link  accstat.obj,'Modules','gdlib'/lib 'optfile'
$ compile_nomms_exit:
$ set process/priority=4
$ set noverify
$ return
$!
$!*****************************
$! Check Platform and Compiler
$!*****************************
$ check_platform:
$ is_alpha = (f$getsyi("HW_MODEL") .gt. 1024)
$ if (is_alpha)
$ then
$   arch = "ALPHA"
$   if (compiler .eqs. "") then compiler = "DECC"
$ else
$   arch = "VAX"
$   if  F$TRNLNM("DECC$CC_DEFAULT") .EQS. "/DECC"
$   then
$      if (compiler .eqs. "") then compiler = "DECC"
$   else
$      if (f$trnlnm("GNU_CC") .nes. "")
$      then
$        if (compiler .eqs. "") then compiler = "GNUC"
$      else
$        if (compiler .eqs. "") then compiler = "VAXC"
$      endif
$   endif
$ endif
$ if (compiler .eqs. "DECC")
$ then
$    CFLAGS = ""
$    CC = "cc"
$    optfile = ""
$ endif
$ if (compiler .eqs. "VAXC")
$ then
$    CFLAGS = ""
$    CC = "cc"
$    optfile = ",share.opt/opt "
$    create share.opt
sys$share:vaxcrtl/share
$ endif
$ if (compiler .eqs. "GNUC")
$ then
$    CFLAGS = ""
$    CC = "gcc"
$    optfile = ",share.opt/opt,gnu_cc:[000000]gcclib/lib "
$    create share.opt
sys$share:vaxcrtl/share
$ endif
$ modules = "modules.obj,config.obj,output.obj,graphics.obj"
$ gdmodules = "gdfontt gdfonts gdfontmb gdfontl gdfontg gd"
$ gdlib = "gd.olb"
$ if ((.not. is_alpha) .and. (vms_version .lts. "V6.0"))
$ then 
$    modules = "''modules',strftime.obj"
$ endif
$ say facility,"-I-ENVIRON,  making ACCSTAT on ''arch' with ''compiler'"
$ return
$!
$!***************************
$! Check Parameters
$!***************************
$ check_parameters:
$!
$ if (make_type .eqs. "")
$ then
$   on error then continue
$   define sys$output nl:
$   define sys$error nl:
$   mms
$   ss_status = $status
$   deassign sys$output 
$   deassign sys$error
$   on error then continue
$   if (ss_status .eq. %X00038090)
$   then
$     on error then continue
$     define sys$output nl:
$     define sys$error nl:
$     mmk
$     ss_status = $status
$     deassign sys$output 
$     deassign sys$error
$     on error then continue
$     if (ss_status .eq. %X00038090)
$     then
$       make_type = "NOMMS"
$     else
$       make_type = "MMK"
$     endif
$   else
$     make_type = "MMS"
$   endif
$ endif
$!
$ if ((make_type .eqs. "MMS") .or. (make_type .eqs. "NOMMS") .or (make_type .eqs. "MMK"))
$ then
$   say facility,"-I-MAKETYPE, making ACCSTAT with ",make_type
$   say facility,"-I-VERSION,  making ACCSTAT on OpenVMS ",vms_version
$ else
$   say facility,"-F-INVMAKE,  make type must be MMS, MMK or NOMMS"
$   exit
$ endif
$!
$ return
$!
$!
$!***************************
$! Process Parameters
$!***************************
$ scan_parameters:
$ n = 1
$   scan_loop:
$   if (n .gt. 8) then goto scan_parameters_exit
$   param = f$edit(p'n',"UPCASE")
$   if (param .nes. "")
$   then
$     if (param .eqs. "MMK") then make_type = "MMK"
$     if (param .eqs. "MMS") then make_type = "MMS"
$     if (param .eqs. "NOMMS") then make_type = "NOMMS"
$     if (param .eqs. "NOMMK") then make_type = "NOMMS"
$     if (param .eqs. "GNUC") then compiler = "GNUC"
$     if (param .eqs. "VAXC") then compiler = "VAXC"
$     if (param .eqs. "DECC") then compiler = "DECC"
$     if (F$EXTRACT(0,1,param) .eqs. "/") then make_options = p'n'
$   endif
$   n = n + 1
$   goto scan_loop
$ scan_parameters_exit:
$ return
$!***************************
$! Final Exit
$!***************************
$ make_exit:
$ if (f$search("share.opt") .nes "") then delete share.opt;*
$ set noverify
$ set process/priority=4
$ exit
